/* output_buffer.h PUBLIC DOMAIN 2016 */
/* part of dqrs <http:///www.purposeful.co.uk/software/dqrs> */
/*
I, Tom Vajzovic, am the author of this software and its documentation.
I permanently abandon all intellectual property rights in them, including
copyright, trademarks, design rights, database right, patents, and the right
to be identified as the author.

I am fairly certain that the software does what the documentation says it
does, but I do not guarantee that it does, or that it does what you think it
should.  I do not guarantee that it will not have undesirable side effects.

You are free to use, modify and distribute this software as you please, but
you do so at your own risk.  If you do not pass on this warning then you may
be responsible for any problems encountered by those who obtain the software
through you.
*/

#ifndef OUTPUT_BUFFER_H_INCLUDED
#define OUTPUT_BUFFER_H_INCLUDED

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

#define BOLD       0x08u
#define RED        0x04u
#define GREEN      0x02u
#define BLUE       0x01u
#define BLACK      0x00u
#define CYAN       (      GREEN | BLUE)
#define MAGENTA    (RED         | BLUE)
#define YELLOW     (RED | GREEN       )
#define WHITE      (RED | GREEN | BLUE)

#define INVERSE    0x80u
#define ON_RED     0x40u
#define ON_GREEN   0x20u
#define ON_BLUE    0x10u
#define ON_BLACK   0x00u
#define ON_CYAN    (         ON_GREEN | ON_BLUE)
#define ON_MAGENTA (ON_RED |            ON_BLUE)
#define ON_YELLOW  (ON_RED | ON_GREEN          )
#define ON_WHITE   (ON_RED | ON_GREEN | ON_BLUE)

void output_mode (unsigned int mode);

void output (const char *buffer, size_t count);

void output_flush (void);

#ifdef __cplusplus
}
#endif

#endif /* OUTPUT_BUFFER_H_INCLUDED */
